'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _debug = require('../debug');

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Scope {
  constructor(options) {
    const value = options.value,
          parent = options.parent;

    this.value = value;
    this.parent = parent;
  }

  clone() {
    return new Scope({
      parent: this.parent,
      value: this.value
    });
  }

  resolveAccessor(path) {
    let scope = this;
    for (let i = 0; i < path.length; i++) {
      const operation = path[i];
      switch (operation.op) {
        case 'attribute':
          scope = new Scope({
            parent: scope,
            value: scope.value[operation.name]
          });
          (0, _debug2.default)(operation.name, '=>', scope.value);
          break;
        default:
          throw `Unkown accessor path element ${operation.op}`;
      }
      if (!scope.value) {
        break;
      }
    }
    return scope;
  }
}
exports.default = Scope;
//# sourceMappingURL=Scope.js.map